import 'package:flutter/material.dart';
import 'package:get/get.dart';

import 'cla_controller.dart';
import 'event.dart';

late Camis_Core _app;
bool initialized = false;
Camis_Core getCamisCore() {
  if (initialized == false) {
    _app = Camis_Core();
    initialized = true;
  }

  return _app;
}

class Camis_Core extends GetView<Camis_Core_Cla_Controller> {
  final List<Camis_Core_Cla_Event> _listener = [];

  Camis_Core() {
    print('build...');
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        title: controller.title.value,
        debugShowCheckedModeBanner: false,
        home: controller.view.value);
  }

  void subscribe(Camis_Core_Cla_Event event) {
    _listener.add(event);
  }

  Future<void> _eventExec(Camis_Core_Typ_Event_Executor type) async {
    await Future.forEach(this._listener, (Camis_Core_Cla_Event e) async {
      if (e.type == type) {
        await e.callback();
      }
    });
  }

  void run() {
    runApp(this);
  }
}
